<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="xml" version="1.0" encoding="UTF-16" indent="yes"/>
	<xsl:template match="/">
		<TNSNAMES>
			<xsl:apply-templates/>
		</TNSNAMES>
	</xsl:template>
	<xsl:template match="TNSNAMES">
		<TNSNAMES>
			<xsl:for-each select="text()|comment">
				<xsl:choose>
					<xsl:when test="local-name(.)!='comment'">
						<DATABASE>
							<xsl:attribute name="name">
								<xsl:value-of select="normalize-space(substring-before(., '='))"/>
							</xsl:attribute>
							<xsl:apply-templates select="following-sibling::node()[1]"/>
						</DATABASE>
					</xsl:when>
					<xsl:otherwise>
						<COMMENT>
							<xsl:attribute name="database-ref">
								<xsl:value-of select="normalize-space(substring-before(following-sibling::text()[1], '='))"/>
							</xsl:attribute>
							<xsl:value-of select="."/>
						</COMMENT>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</TNSNAMES>
	</xsl:template>
	<xsl:template match="paren">
		<xsl:param name="tagname" select="normalize-space(substring-before(text(), '='))"/>
		<xsl:param name="start" select="@pos"/>
		<xsl:param name="end" select="parenend/@pos"/>
		<xsl:choose>
			<xsl:when test="contains(text(), '=')">
				<xsl:element name="{$tagname}">
					<xsl:attribute name="start"><xsl:value-of select="$start"/></xsl:attribute>
					<xsl:attribute name="length"><xsl:value-of select="($end)-($start)"/></xsl:attribute>
					<xsl:attribute name="id"><xsl:value-of select="generate-id()"/></xsl:attribute>
					<xsl:if test="string-length(normalize-space(substring-after(text(), '='))) &gt; 0">
						<xsl:value-of select="normalize-space(substring-after(text(), '='))"/>
					</xsl:if>
					<xsl:apply-templates select="*"/>
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="."/>
				<xsl:apply-templates/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
