<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.1" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" version="1.0" encoding="UTF-16" indent="yes"/>
	<!--	<xsl:template match="/">
		<html>
			<body>
				<ul>
					<xsl:if test="count(TNSNAMES)!=1">
						<error>
							<id>
								<xsl:value-of select="@id" />
							</id>
							<msg>Root node must be TNSNAMES</msg>
						</error>
					</xsl:if>
					<xsl:apply-templates />
				</ul>
			</body>
		</html>
	</xsl:template>
-->
	<xsl:template match="TNSNAMES|tnsnames">
		<error-list>
			<xsl:if test="count(DATABASE)=0">
				<error>
					<id>
						<xsl:value-of select="@id" />
					</id>
					<msg>TNSNAMES must contain one or more DATABASE.</msg>
				</error>
			</xsl:if>
			<xsl:apply-templates />
		</error-list>
	</xsl:template>
	<xsl:template match="DATABASE|database">
		<xsl:if test="name(parent::*)!='TNSNAMES'">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DATABASE parent must be TNSNAMES.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(DESCRIPTION|DESCRIPTION_LIST)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DATABASE must contain one or more of these tokens: DESCRIPTION or DESCRIPTION_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="DESCRIPTION_LIST|description_list">
		<xsl:if test="name(parent::*)!='DATABASE'">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DESCRIPTION_LIST parent must be DATABASE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(DESCRIPTION|ADDRESS_LIST)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DESCRIPTION_LIST must contain one or more of these tokens: DESCRIPTION or ADDRESS_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="DESCRIPTION|description">
		<xsl:if test="(name(parent::*)!='DATABASE') and (name(parent::*)!='DESCRIPTION_LIST')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DESCRIPTION parent must be DATABASE or DESCRIPTION_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(ADDRESS_LIST|ADDRESS)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DESCRIPTION must contain one or more of these tokens: ADDRESS_LIST or ADDRESS.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(CONNECT_DATA)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DESCRIPTION must contain one or more CONNECT_DATA tokens.</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="ADDRESS_LIST|address_list">
		<xsl:if test="(name(parent::*)!='DESCRIPTION_LIST') and (name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS_LIST parent must be DESCRIPTION_LIST or DESCRIPTION,</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(ADDRESS)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS_LIST contain at least one ADDRESS.</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="ADDRESS|address">
		<xsl:if test="(name(parent::*)!='DESCRIPTION') and (name(parent::*)!='ADDRESS_LIST')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS parent must be DESCRIPTION_LIST or DESCRIPTION</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(PROTOCOL)>1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS can only one PROTOCOL</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(HOST)>1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS can contain only one HOST</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(PORT)>1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS can contain only one PORT</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(PIPE)>1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS can contain only one PIPE</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(KEY)>1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>ADDRESS can contain only one KEY</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="CONNECT_DATA|connect_data">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>CONNECT_DATA parent must be DESCRIPTION.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(SERVICE_NAME|SID)!=1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>CONNECT_DATA must contain one and only one SERVICE_NAME or SID</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="SECURITY|security">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SECURITY parent must be DESCRIPTION</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(SSL_SERVER_CERT_DN)!=1">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SECURITY must contain one and only one SSL_SERVER_CERT_DN</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="PROTOCOL|protocol">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PROTOCOL parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PROTOCOL cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~TCP~TCPS~SPX~NMP~IPC~tcp~tcps~spx~nmp~ipc~' , concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for PROTOCOL.  Must be TCP,TCPS,SPX, or IPC.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="HOST|host">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>HOST parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>HOST cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>HOST has no text</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="PORT|port">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PORT parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PORT cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text()) &lt; 0) or (number(text())*0 != 0)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PORT must be a positive integer.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="COMMUNITY|community">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>COMMUNITY parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>COMMUNITY cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>COMMUNITY has no text</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="KEY|key">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>KEY parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>KEY cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>KEY has no text</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="PIPE|pipe">
		<xsl:if test="(name(parent::*)!='ADDRESS')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PIPE parent must be ADDRESS</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PIPE cannot contain other TOKENS</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PIPE has no text</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="FAILOVER|failover">
		<xsl:if test="not(contains('~DESCRIPTION_LIST~DESCRIPTION~ADDRESS_LIST~', concat('~', name(parent::*), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>FAILOVER parent must be DESCRIPTION_LIST, DESCRIPTION, or ADDRESS_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>FAILOVER cannot contain other TOKENS.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~on~off~yes~no~true~false~ON~OFF~YES~NO~TRUE~FALSE~', concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for FAILOVER.  Must be on,off,yes,no,true, or false.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="LOAD_BALANCE|load_balance">
		<xsl:if test="not(contains('~DESCRIPTION_LIST~DESCRIPTION~ADDRESS_LIST~', concat('~', name(parent::*), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>LOAD_BALANCE parent must be DESCRIPTION_LIST, DESCRIPTION, or ADDRESS_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>LOAD_BALANCE cannot contain other TOKENS.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~on~off~yes~no~true~false~ON~OFF~YES~NO~TRUE~FALSE~', concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for LOAD_BALANCE.  Must be on,off,yes,no,true, or false.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="RECV_BUF_SIZE|recv_buf_size">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RECV_BUF_SIZE parent must be DESCRIPTION.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RECV_BUF_SIZE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text()) &lt; 0) or (number(text())*0 != 0)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RECV_BUF_SIZE must be a positive integer.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SDU|sdu">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SDU parent must be DESCRIPTION.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SDU cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text())*0 != 0) or (number(text()) &lt; 512) or (number(text()) > 32768)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SDU must be an integer between 512 bytes and 32768 bytes (32 KB).</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SEND_BUF_SIZE|send_buf_size">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SEND_BUF_SIZE parent must be DESCRIPTION</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SEND_BUF_SIZE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text())*0 != 0)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SEND_BUF_SIZE must be a positive integer.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SOURCE_ROUTE|source_route">
		<xsl:if test="not(contains('~DESCRIPTION_LIST~DESCRIPTION~ADDRESS_LIST~', concat('~', name(parent::*), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SOURCE_ROUTE parent must be DESCRIPTION_LIST, DESCRIPTION, or ADDRESS_LIST.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SOURCE_ROUTE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~on~off~yes~no~ON~OFF~YES~NO~', concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for SOURCE_ROUTE.  Must be on,off,yes, or no.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="TYPE_OF_SERVICE|type_of_service">
		<xsl:if test="(name(parent::*)!='DESCRIPTION')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE_OF_SERVICE parent must be DESCRIPTION.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE_OF_SERVICE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE_OF_SERVICE has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="FAILOVER_MODE|failover_mode">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>FAILOVER_MODE parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(BACKUP|TYPE|METHOD|RETRIES|DELAY)=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>FAILOVER_MODE must contain one or more of these tokens: BACKUP,TYPE,METHOD,RETRIES, or DELAY.</msg>
			</error>
		</xsl:if>
		<xsl:apply-templates />
	</xsl:template>
	<xsl:template match="BACKUP|backup">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="BACKUP|backup">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>BACKUP has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="TYPE|type">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~session~select~none~SESSION~SELECT~NONE~' , concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for TYPE.  Must be session, select, or none.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="TYPE|type">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>TYPE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~session~select~none~SESSION~SELECT~NONE~' , concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for TYPE.  Must be session, select, or none.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="METHOD|method">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>METHOD parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>METHOD cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~basic~preconnect~BASIC~PRECONNECT~', concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for METHOD.  Must be basic or preconnect.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="RETRIES|retries">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RETRIES parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RETRIES cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text()) &lt; 0) or (number(text())*0 != 0)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RETRIES must be a positive integer.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="DELAY|delay">
		<xsl:if test="(name(parent::*)!='FAILOVER_MODE')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DELAY parent must be FAILOVER_MODE.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DELAY cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(number(text()) &lt; 0) or (number(text())*0 != 0)">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>DELAY must be a positive integer.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="GLOBAL_NAME|global_name">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>GLOBAL_NAME parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>GLOBAL_NAME cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>GLOBAL_NAME has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="HS|hs">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>HS parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>HS cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="not(contains('~ok~none~OK~NONE~' , concat('~', text(), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for HS.  Must be ok or none.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="INSTANCE_NAME|instance_name">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>INSTANCE_NAME parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>INSTANCE_NAME cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>INSTANCE_NAME has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="RDB_DATABASE|rdb_database">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RDB_DATABASE parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RDB_DATABASE cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>RDB_DATABASE has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SERVER|server">
		<xsl:if test="not(contains('~CONNECT_DATA~ADDRESS~', concat('~', name(parent::*), '~')))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SERVER parent must be CONNECT_DATA or ADDRESS.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SERVER cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="(name(parent::*)='CONNECT_DATA') and (not(contains('~default~dedicated~shared~DEFAULT~DEDICATED~SHARED~' , concat('~', text(), '~'))))">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Invalid value for SERVER.  Must be default, dedicated or shared.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SERVICE_NAME|service_name">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SERVICE_NAME parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SERVICE_NAME cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SERVICE_NAME has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="PRESENTATION|presentation">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PRESENTATION parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PRESENTATION cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>PRESENTATION has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SRVR|srvr">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SRVR parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SRVR cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SRVR has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SID|sid">
		<xsl:if test="(name(parent::*)!='CONNECT_DATA')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SID parent must be CONNECT_DATA.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SID cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SID has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>
	<xsl:template match="SSL_SERVER_CERT_DN|ssl_server_cert_dn">
		<xsl:if test="(name(parent::*)!='SECURITY')">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SSL_SERVER_CERT_DN parent must be SECURITY.</msg>
			</error>
		</xsl:if>
		<xsl:if test="count(child::*)!=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SSL_SERVER_CERT_DN cannot contain other tokens.</msg>
			</error>
		</xsl:if>
		<xsl:if test="string-length(text())=0">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>SSL_SERVER_CERT_DN has no text.</msg>
			</error>
		</xsl:if>
	</xsl:template>

	<xsl:template match="COMMENT|comment">
	</xsl:template>

	<xsl:template match="*">
			<error>
				<id>
					<xsl:value-of select="@id" />
				</id>
				<msg>Undefined parameter, '<xsl:value-of select="name(.)"/>'</msg>
			</error>
			<xsl:apply-templates select="*"/>
	</xsl:template>
</xsl:stylesheet>